Triggering 'Run puppet' from GUI returns 500 error
Description

Hello,

I am using following foreman and foreman-proxy versions:

foreman: pre-0.5 (last git commit: dda8e2b951d52a5bfff13317f0b34a9a3c479574)
foreman-proxy: last git commit (aa0a791aa817b0a6a911fa3abe3341a3967dd698)

When triggering 'Run puppet' from Foreman GUI, 'failed to execute puppetrun: 500 Internal Server Error' message is returned, but
Puppet agent is triggered successfully on node.

Foreman-proxy configuration was done according this documentation:

http:/theforeman.org/projects/smart-proxy/wiki/Settingsyml

Snippet from foreman-proxy.log after triggering 'Run puppet'":
E, [2012-03-26T09:29:22.954497 #24332] ERROR -- : Failed puppet run: Check Log files
You can find foreman and foreman-proxy configuration files attached to this ticket.

This bug is low priority and not a show stopper, but it might confuse Foreman GUI users.

History

#1 - 04/03/2012 04:11 PM - Ohad Levy
- Status changed from New to Feedback
- Assignee deleted (Ohad Levy)

- Target version deleted (1.0)

is sudo configured correctly? including the tty bits?
#2 - 04/04/2012 09:17 AM - Povilas Daukintis

Ohad Levy wrote:

is sudo configured correctly? including the tty bits?

Yes, /etc/sudoers file contains these items:

foreman-proxy ALL = NOPASSWD: /usr/sbin/puppetrun
foreman—-proxy ALL = NOPASSWD: /usr/bin/puppet
Defaults:foreman-proxy !requiretty

| can successfully trigger puppet run as foreman-proxy user via shell:

$ whoami
http://theforeman.org/projects/smart-proxy/wiki/Settingsyml
https://projects.theforeman.org/issues/24332

foreman—-proxy

$ /usr/bin/sudo -S /usr/sbin/puppetrun --host virt2
Triggering virt2

Getting status

status 1is success

virt2 finished with exit code 0

Finished

Also, when triggering puppet run via Foreman's GUI 'Run puppet' | can see that command is executed on foreman host:

Apr 4 16:11:40 bootstraper sudo: foreman-proxy : TTY=unknown ; PWD=/ ; USER=root ; COMMAND=/usr/sbin/puppetru

n —--host virt2
Also, Puppet agent is triggered on client node:

Apr 4 16:11:41 virt2 puppet-agent[11061]: triggered run
Apr 4 16:11:45 virt2 puppet-agent[11061]: Finished catalog run in 2.01 seconds

But despite that, foreman-proxy still logs error and returns 500 error:
E, [2012-04-04T16:11:41.965285 #21956] ERROR —-- : Failed puppet run: Check Log files
foreman-proxy is running with debug log level enabled but no more useful information is logged.
#3 - 04/04/2012 09:37 AM - Povilas Daukintis
- File puppetrb.patch added
| have spent some more time digging around, and it seems that condition in lib/proxy/puppet.rb is never met:
unless command =~ /finished with exit code 0/
| have changed code a little bit, to check for exit code, and everything is working again.
| have attached a patch to this ticket as a attachment.
#4 - 04/04/2012 02:14 PM - Povilas Daukintis
Povilas Daukintis wrote:
| have spent some more time digging around, and it seems that condition in lib/proxy/puppet.rb is never met:
[--]
| have changed code a little bit, to check for exit code, and everything is working again.

| have attached a patch to this ticket as a attachment.

Forgot to mention that these changes were applied to foreman-proxy codebase.

#5 - 11/13/2012 12:03 PM - Greg Sutcliffe

- Target version set to Bug scrub

#6 - 11/15/2012 11:28 AM - Sam Kottler

- Assignee set to Sam Kottler

I'm working on this now. Thanks for the patch @Povilas!

#7 - 06/18/2013 11:42 AM - Benjamin Papillon
- Status changed from Feedback to Closed

We are checking the return code now, so this ticket can be closed.
Thanks for reporting!

Files

foreman_proxy_settings.yaml 415 Bytes 03/26/2012 Povilas Daukintis
foreman_settings.yaml 81 Bytes 03/26/2012 Povilas Daukintis
puppetrb.patch 665 Bytes 04/04/2012 Povilas Daukintis
